unit StdDlg;
{$O+,F+,V-,X+,I-,S-}
interface

uses Objects, Drivers, Views, Dialogs, Dos, Box_Obj, FileView, Drive;

const  cmFileOpen          = 200;
       cmFileStep          = 201;
       cmFileDisk          = 202;
       cmFileView          = 203;
       cmFileMask          = 204;
       cmFileSort          = 205;

       cmFileFocused       = 206;
       cmFileDoubleClicked = 207;

type   String2 = String[2];
       String4 = String[4];

       TSearchRec = record
         Attr: Byte;
         Time: Longint;
         Size: Longint;
         Name: string[12];
       end;

type   PFileCollection = ^TFileCollection;
       TFileCollection = object(TSortedCollection)
         function  Compare(Key1, Key2: Pointer): Integer; virtual;
         procedure FreeItem(Item: Pointer); virtual;
       end;

       PSortedListBox = ^TSortedListBox;
       TSortedListBox = object(TListBox)
         constructor Init(var Bounds: TRect; ANumCols: Word; AScrollBar: PScrollBar);
         procedure   HandleEvent(var Event: TEvent); virtual;
         procedure   NewList(AList: PCollection);    virtual;
       end;

       PFileList = ^TFileList;
       TFileList = object(TSortedListBox)
         constructor Init(var Bounds: TRect; AScrollBar: PScrollBar);
         destructor  Done;                                            virtual;
         procedure   Draw;                                            virtual;
         function    DataSize: Word;                                  virtual;
         procedure   FocusItem(Item: Integer);                        virtual;
         function    GetText(Item: Integer; MaxLen: Integer): String; virtual;
         procedure   HandleEvent(var Event: TEvent);                  virtual;
         procedure   SetData(var Rec);                                virtual;
         procedure   ReadDirectory(AWildCard: PathStr);
       end;

       PFileInfoPane = ^TFileInfoPane;
       TFileInfoPane = object(TView)
         S:          TSearchRec;
         constructor Init(var Bounds: TRect);
         procedure   Draw; virtual;
         function    GetPalette: PPalette; virtual;
         procedure   HandleEvent(var Event: TEvent); virtual;
       end;

       TWildStr = PathStr;

type   PFileDialog = ^TFileDialog;
       TFileDialog = Object(TDialog)
         FileList  : PFileList;
         WildCard  : TWildStr;
         Directory : PString;
         CurDir    : PString;
         constructor Init(AWildCard: TWildStr);
         procedure   GetFileName(var S: PathStr);
         destructor  Done;                                 virtual;
         function    GetTitle(MaxSize: Integer):TTitleStr; virtual;
         procedure   GetData(var Rec);                     virtual;
         procedure   HandleEvent(var Event: TEvent);       virtual;
         function    Valid(Command: Word): Boolean;        virtual;
         private
         procedure ReadDirectory;
       end;

       PBoxNc = ^TBoxNc;
       TBoxNc = object(TBox)
         procedure   Draw; virtual;
       end;

const  CInfoPane = CListViewer;

implementation
uses App, Memory, HistList, MsgBox;

{Ĵ Small procedure ı}
procedure TBoxNc.Draw;
var B: TDrawBuffer;
    C: Byte;
    W: Word;
    I: byte;
begin
  C := GetColor(1);
  W := $3E30;
  MoveChar(B, ' ', C, Size.X);
  for i:=0 to Size.Y-1 do WriteLine(0, I, Size.X, 1, B);
  MoveCStr(B, '    ~~     ~~ ~~    ~~   ~६~', W);
  WriteLine(2, 1, Size.X, 1, B);
  MoveChar(B, ' ', C, Size.X);
  MoveChar(B, '', C, Size.X);
  WordRec(B[0]).Lo       :=218;
  WordRec(B[14]).Lo      :=194;
  WordRec(B[18]).Lo      :=194;
  WordRec(B[28]).Lo      :=194;
  WordRec(B[37]).Lo      :=194;
  WordRec(B[Size.X-1]).Lo:=191;
  WriteLine(0, 0, Size.X, 1, B);
  MoveChar(B, '', C, Size.X);
  WordRec(B[0]).Lo:=192;
  WordRec(B[Size.X-1]).Lo:=217;
  WriteLine(0, Size.Y-1, Size.X, 1, B);
  MoveChar(B, ' ', C, Size.Y-2);
  MoveChar(B, '', C, Size.Y-2);
  WriteLine(0, 1, 1, Size.Y-2, B);
  WriteLine(Size.X-1, 1, 1, Size.Y-2, B);
  MoveChar(B, ' ', C, Size.X);
  MoveChar(B, '', C, Size.X);
  WordRec(B[0]).Lo       :=195;
  WordRec(B[14]).Lo      :=193;
  WordRec(B[18]).Lo      :=193;
  WordRec(B[28]).Lo      :=193;
  WordRec(B[37]).Lo      :=193;
  WordRec(B[Size.X-1]).Lo:=180;
  WriteLine(0, Size.Y-3, Size.X, 1, B);
end;

function DriveValid(Drive: Char): Boolean; near; assembler;
asm
    MOV AH,19H
    INT 21H
    MOV BL,AL
    MOV DL,Drive
    SUB DL,'A'
    MOV AH,0EH
    INT 21H
    MOV AH,19H
    INT 21H
    MOV CX,0
    CMP AL,DL
    JNE @@1
    MOV CX,1
    MOV DL,BL
    MOV AH,0EH
    INT 21H
@@1:XCHG  AX,CX
end;

function PathValid(var Path: PathStr): Boolean;
var ExpPath: PathStr;
    F      : File;
    SR     : SearchRec;
begin
  ExpPath := FExpand(Path);
  if Length(ExpPath) <= 3
  then PathValid := DriveValid(ExpPath[1])
  else begin
    if ExpPath[Length(ExpPath)] = '\' then Dec(ExpPath[0]);
    FindFirst(ExpPath, Directory, SR);
    PathValid := (DosError = 0) and (SR.Attr and Directory <> 0);
  end;
end;

function CheckDirectory(var S: PathStr): Boolean;
begin
  if not PathValid(S) then begin
    MessageBox(#3' ⮢ ன⢠.', nil, mfError + mfOkButton);
    CheckDirectory := False;
  end
  else CheckDirectory := True;
end;

function ValidFileName(var FileName: PathStr): Boolean;
const IllegalChars = ';,=+<>|"[] \';
var
  Dir : DirStr;
  Name: NameStr;
  Ext : ExtStr;

function Contains(S1, S2: String): Boolean; near; assembler;
asm
      PUSH  DS
      CLD
      LDS   SI,S1
      LES   DI,S2
      MOV   DX,DI
      XOR   AH,AH
      LODSB
      MOV   BX,AX
      OR    BX,BX
      JZ    @@2
      MOV   AL,ES:[DI]
      XCHG  AX,CX
@@1:  PUSH  CX
      MOV   DI,DX
      LODSB
      REPNE SCASB
      POP   CX
      JE    @@3
      DEC   BX
      JNZ   @@1
@@2:  XOR   AL,AL
      JMP   @@4
@@3:  MOV   AL,1
@@4:  POP   DS
end;

begin
  ValidFileName := True;
  FSplit(FileName, Dir, Name, Ext);
  if not ((Dir = '') or PathValid(Dir)) or Contains(Name, IllegalChars) or
    Contains(Dir, IllegalChars) then ValidFileName := False;
end;

function GetCurDir: DirStr;
var CurDir: DirStr;
begin
  GetDir(0, CurDir);
  if Length(CurDir) > 3 then begin
    Inc(CurDir[0]);
    CurDir[Length(CurDir)] := '\';
  end;
  GetCurDir := CurDir;
end;

type PSearchRec = ^TSearchRec;

function IsWild(const S: String): Boolean;
begin
  IsWild := (Pos('?',S) > 0) or (Pos('*',S) > 0);
end;

function IsDir(const S: String): Boolean;
var SR: SearchRec;
begin
  FindFirst(S, Directory, SR);
  if DosError = 0 then
    IsDir := SR.Attr and Directory <> 0
  else IsDir := False;
end;

function  DelSpace(Mess : string):string;
var Mes_s : string;
    C     : byte;
begin
  Mes_s:='';
  for C:=1 to length(Mess) do if Mess[C]<>' ' then Mes_s:=Mes_s+Mess[C];
  DelSpace:=Mes_s;
end;

function Rat(Cha_r: char; Mess : string):byte;
var C : byte;
begin
  for C:=length(Mess) downto 1 do
    if copy(Mess,C,1)=Cha_r then begin Rat:=C; exit; end;
  Rat:=0;
end;

procedure UpperCase(var s:string);
var i : Integer;
begin
  for i := 1 to Length(s) do s[i] := Upcase(s[i]);
end;

procedure LowerCase(var s:string);
var i : Integer;
begin
  for i := 1 to Length(s) do if s[i] in ['A'..'Z'] then Inc(s[i], 32);
end;

function Pad(s: String; Len: Byte): String;
begin
  if Length(s) < Len then FillChar(s[Succ(Length(s))], Len-Length(s), ' ');
  s[0] := Char(Len);
  Pad := s;
end;

function FullTrim(const Original: String): String;
var S: String;
begin
  S := Original;
  while (S[0] > #0) and (S[Length(S)] = #32) do Dec(S[0]);  { trim left }
  while (S[0] > #0) and (S[1] = #32) do begin
    Move(S[2], S[1], Pred(Length(S)));
    Dec(S[0]);
  end;
  FullTrim := S;
end;

function TwoDigit(W: Word; Pad: Boolean) : String2;
var s: String2;
begin
  Str(W:2, s);
  if Pad and (s[1] = ' ') then s[1] := '0';
  TwoDigit := s;
end;

function FourDigit(W: Word) : String4;
var s: String4;
begin
  Str(W:4, s);
  FourDigit := s;
end;

function FormatDateTime(DT: Longint): String;
var S: String;
    T: DateTime;
begin
  UnpackTime(DT, t);
  S:='';
  S:=S+TwoDigit(t.Month, False) + '-' + TwoDigit(t.Day, True);
  S:=S+'-' + Copy(FourDigit(t.Year),3,2);
  S:=S+'';
  if T.Hour<12
  then s:=s+TwoDigit(t.Hour,false)+':'+TwoDigit(t.Min,true)+'a'
  else if T.Hour=12
      then s:=s+TwoDigit(t.Hour,false)+':'+TwoDigit(t.Min,true)+'p'
      else s:=s+TwoDigit(t.Hour-12,false)+':'+TwoDigit(t.Min,true)+'p';
  FormatDateTime := s;
end;

function FormatAttr(Attr: Word): String4;
var
  s: String4;
begin
  s := '';
  if Attr and Archive = Archive then s[1] := 'A';
  if Attr and ReadOnly = ReadOnly then s[2] := 'R';
  if Attr and SysFile = SysFile then s[3] := 'S';
  if Attr and Hidden = Hidden  then s[4] := 'H';
  FormatAttr := s;
end;

function FormatNameExt(SR: TSearchRec): string;
var Name : string[9];
    Ext  : string[3];
    Mess : string[12];
begin
  Mess:=SR.Name;
  if SR.Attr and Directory=0 then LowerCase(Mess);
  if (Pos('.',Mess)>0) and (Pos('..',Mess)=0) then begin
    Name:=Pad(Copy(Mess,1,Pos('.',Mess)-1),9);
    Ext :=Pad(Copy(Mess,Pos('.',Mess)+1,3),3);
  end
  else begin
    Name:=Pad(Mess,9);
    Ext :='   ';
  end;
  FormatNameExt:=Name+Ext;
end;

function FormatSize(MySize: LongInt):String;
var S: string;
begin
  if MySize<>0
  then Str(MySize:9,S)
  else S:=Pad(' ',9);
  FormatSize:=S;
end;

{Ĵ TFileCollection ı}

function TFileCollection.Compare(Key1, Key2: Pointer): Integer;
begin
  if PSearchRec(Key1)^.Name = PSearchRec(Key2)^.Name
  then Compare := 0
  else if PSearchRec(Key1)^.Name = '..'
       then Compare := -1
       else if PSearchRec(Key2)^.Name = '..'
            then Compare := 1
            else if (PSearchRec(Key1)^.Attr and Directory <> 0) and (PSearchRec(Key2)^.Attr and Directory = 0)
                 then Compare := -1
                 else if (PSearchRec(Key2)^.Attr and Directory <> 0) and (PSearchRec(Key1)^.Attr and Directory = 0)
                      then Compare := 1
                      else if PSearchRec(Key1)^.Name > PSearchRec(Key2)^.Name
                           then Compare := 1
                           else Compare := -1;
end;

procedure TFileCollection.FreeItem(Item: Pointer);
begin
  Dispose(PSearchRec(Item));
end;

{Ĵ TSortedListBox ı}

constructor TSortedListBox.Init(var Bounds: TRect; ANumCols: Word; AScrollBar: PScrollBar);
begin
  TListBox.Init(Bounds, ANumCols, AScrollBar);
end;

procedure TSortedListBox.HandleEvent(var Event: TEvent);
begin
  TListBox.HandleEvent(Event);
  if Event.What = evKeyDown then begin
    case Event.KeyCode of
      kbEnter : begin
                  Event.What    := evCommand;
                  Event.Command := cmOK;
                  PutEvent(Event);
                  ClearEvent(Event);
                end;
    end;
  end;
end;

procedure TSortedListBox.NewList(AList: PCollection);
begin
  TListBox.NewList(AList);
end;

{Ĵ TFileList ı}

constructor TFileList.Init(var Bounds: TRect; AScrollBar: PScrollBar);
begin
  TSortedListBox.Init(Bounds, 1, AScrollBar);
end;

destructor TFileList.Done;
begin
  if List <> nil then Dispose(List, Done);
  TListBox.Done;
end;

function TFileList.DataSize: Word;
begin
  DataSize := 0;
end;

procedure TFileList.Draw;
var B: TDrawBuffer;
    C: Byte;
    S: string;
begin
  inherited Draw;
  if List^.Count<Size.Y then begin
    C:=GetColor(1);
    S:='                                ';
    MoveStr(B[0], S, C);
    WriteLine(1, List^.Count, Length(S), Size.Y-List^.Count, B);
  end;
end;

procedure TFileList.FocusItem(Item: Integer);
begin
  TSortedListBox.FocusItem(Item);
  Message(Owner, evBroadcast, cmFileFocused, List^.At(Item));
end;

function TFileList.GetText(Item: Integer; MaxLen: Integer): String;
var S : String;
    SR: PSearchRec;
begin
  S:='';
  if Item<List^.Count then begin
    SR := PSearchRec(List^.At(Item));
    S  :='';
    S  :=FormatNameExt( PSearchRec( SR )^);
    if SR^.Attr and Directory <> 0
    then if SR^.Name='..'
         then S:=S+'  '
         else S:=S+' '
    else if (Pos(' exe',S)>0) or (Pos(' com',S)>0) or (Pos(' bat',S)>0)
         then S:=S+' '
         else S:=S+' ';
    S:=S+''+FormatSize(SR^.Size);
    S:=S+''+FormatDateTime(SR^.Time);
  end
  else S:='';
  GetText := S;
end;

procedure TFileList.HandleEvent(var Event: TEvent);
begin
  if (Event.What = evMouseDown) and (Event.Double) then begin
    Event.What    := evCommand;
    Event.Command := cmFileOpen;
    PutEvent(Event);
    ClearEvent(Event);
  end
  else TSortedListBox.HandleEvent(Event);
end;

procedure TFileList.ReadDirectory(AWildCard: PathStr);
const
  FindAttr = ReadOnly + Archive;
  AllFiles = '*.*';
  PrevDir  = '..';
var
  S       : SearchRec;
  P       : PSearchRec;
  FileList: PFileCollection;
  NumFiles: Word;
  CurPath : PathStr;
  Dir     : DirStr;
  Name    : NameStr;
  Ext     : ExtStr;
  Event   : TEvent;
  Tmp     : PathStr;
  Flag    : Integer;
begin
  NumFiles := 0;
  AWildCard := FExpand(AWildCard);
  FSplit(AWildCard, Dir, Name, Ext);
  FileList := New(PFileCollection, Init(5, 5));
  FindFirst(AWildCard, FindAttr, S);
  P := @P;
  while (P <> nil) and (DosError = 0) do begin
    if (S.Attr and Directory = 0) then begin
      P := MemAlloc(SizeOf(P^));
      if P <> nil then begin
        Move(S.Attr, P^, SizeOf(P^));
        FileList^.Insert(P);
      end;
    end;
    FindNext(S);
  end;
  Tmp := Dir + AllFiles;
  FindFirst(Tmp, Directory, S);
  while (P <> nil) and (DosError = 0) do begin
    if (S.Attr and Directory <> 0) and (S.Name[1] <> '.') then begin
      P := MemAlloc(SizeOf(P^));
      if P <> nil then begin
        Move(S.Attr, P^, SizeOf(P^));
        FileList^.Insert(PObject(P));
      end;
    end;
    FindNext(S);
  end;
  if Length(Dir) > 4 then begin
    P := MemAlloc(SizeOf(P^));
    if P <> nil then begin
      FindFirst(Tmp, Directory, S);
      FindNext(S);
      if (DosError = 0) and (S.Name = PrevDir)
      then Move(S.Attr, P^, SizeOf(P^))
      else begin
        P^.Name := PrevDir;
        P^.Size := 0;
        P^.Time := $210000;
        P^.Attr := Directory;
      end;
      FileList^.Insert(PObject(P));
    end;
  end;
  if P = nil then MessageBox('Too many files.', nil, mfOkButton + mfWarning);
  NewList(FileList);
  Owner^.Last^.DrawView;
  if List^.Count > 0 then begin
    Event.What    := evBroadcast;
    Event.Command := cmFileFocused;
    Event.InfoPtr := List^.At(0);
    Owner^.HandleEvent(Event);
  end;
end;

procedure TFileList.SetData(var Rec);
begin
  with PFileDialog(Owner)^ do
    Self.ReadDirectory(Directory^ + WildCard);
end;

{Ĵ TFileInfoPane ı}

constructor TFileInfoPane.Init(var Bounds: TRect);
begin
  TView.Init(Bounds);
  EventMask := EventMask or evBroadcast;
end;

procedure TFileInfoPane.Draw;
var Str  : String;
    B    : TDrawBuffer;
    Color: Word;
begin
  Str:='';
  Str:=FormatNameExt(S);
  if S.Attr and Directory <> 0
  then if S.Name='..'
       then Str:=Str+'   '
       else Str:=Str+'  '
  else if (Pos(' exe',Str)>0) or (Pos(' com',Str)>0) or (Pos(' bat',Str)>0)
       then Str:=Str+'  '
       else Str:=Str+'  ';
  Str:=Str+' '+FormatSize(S.Size);
  Str:=Str+' '+FormatDateTime(S.Time);
  Str[Pos('',Str)]:=' ';
  Color := GetColor($01);
  MoveChar (B, ' ', Color, Size.X);
  WriteLine(0, 0, Size.X, 1, B);
  MoveStr  (B[1], Str, Color);
  WriteLine(0, 0, Size.X, 1, B);
end;

function TFileInfoPane.GetPalette: PPalette;
const P: String[Length(CInfoPane)] = CInfoPane;
begin
  GetPalette := @P;
end;

procedure TFileInfoPane.HandleEvent(var Event: TEvent);
begin
  TView.HandleEvent(Event);
  if (Event.What = evBroadcast) and (Event.Command = cmFileFocused) then begin
    S := PSearchRec(Event.InfoPtr)^;
    DrawView;
  end;
end;

{Ĵ TFileDialog ı}

constructor TFileDialog.Init(AWildCard: TWildStr);
var Control: PView;
    R      : TRect;
    S      : String;
begin
  R.Assign(0,0,65,21);
  TDialog.Init(R, '');
  Options  := Options or ofCentered or ofBuffered;
  WildCard := AWildCard;

  R.Assign(2,2,48,18);
  Control := New(PBoxNc, Init(R));
  Insert(Control);

  R.Assign(47,4,48,15);
  Control := New(PScrollBar, Init(R));
  Insert(Control);
  R.Assign(3,4,47,15);
  FileList := New(PFileList, Init(R, PScrollBar(Control)));
  Insert(FileList);

  R.Assign(3,16,47,17);
  Control := New(PFileInfoPane, Init(R));
  Insert(Control);

  R.Assign(51,2,63,4); Insert(New(PButton, Init(R, '~~',  cmFileOpen, bfDefault)));
  R.Move  (0,2);       Insert(New(PButton, Init(R, '~~३',  cmFileStep, bfNormal)));
  R.Move  (0,2);       Insert(New(PButton, Init(R, '~~', cmFileView, bfNormal)));
  R.Move  (0,2);       Insert(New(PButton, Init(R, '~~',     cmFileDisk, bfNormal)));
  R.Move  (0,2);       Insert(New(PButton, Init(R, '~~᪠',    cmFileMask, bfNormal)));
  R.Move  (0,2);       Insert(New(PButton, Init(R, '~~冷',  cmFileSort, bfNormal)));
  R.Move  (0,2);       Insert(New(PButton, Init(R, '~~',    cmCancel,   bfNormal)));

  SelectNext(False);

  ReadDirectory;
  CurDir:=NewStr(Directory^);
end;

destructor TFileDialog.Done;
begin
  ChDir(CurDir^);
  DisposeStr(Directory);
  DisposeStr(CurDir);
  TDialog.Done;
end;

procedure TFileDialog.GetData(var Rec);
begin
  GetFilename(PathStr(Rec));
end;

procedure TFileDialog.GetFileName(var S: PathStr);
var
  Path : PathStr;
  Name : NameStr;
  Ext  : ExtStr;
  TPath: PathStr;
  TName: NameStr;
  TExt : NameStr;
  Value: Integer;

function LTrim(const S: String): String;
var I: Integer;
begin
  I := 1;
  while (I < Length(S)) and (S[I] = ' ') do Inc(I);
  LTrim := Copy(S, I, 255);
end;

function RTrim(const S: String): String;
var I: Integer;
begin
  I := Length(S);
  while S[I] = ' ' do Dec(I);
  RTrim := Copy(S, 1, I);
end;

function RelativePath(var S: PathStr): Boolean;
var I,J: Integer;
    P  : PathStr;
begin
  S := LTrim(RTrim(S));
  if (S <> '') and ((S[1] = '\') or (S[2] = ':'))
  then RelativePath := False
  else RelativePath := True;
end;

function NoWildChars(S: String): String; near; assembler;
asm
     PUSH  DS
     LDS   SI,S
     XOR   AX,AX
     LODSB
     XCHG  AX,CX
     LES   DI,@Result
     INC   DI
     JCXZ  @@3
@@1: LODSB
     CMP   AL,'?'
     JE    @@2
     CMP   AL,'*'
     JE    @@2
     STOSB
@@2: LOOP  @@1
@@3: XCHG  AX,DI
     MOV   DI,WORD PTR @Result
     SUB   AX,DI
     DEC   AX
     STOSB
     POP   DS
end;

begin
  Value:=FileList^.Focused;
  S:= Copy(FileList^.GetText(Value,255),1,12);
  if S[10]<>' ' then S[9]:='.';
  S:=DelSpace(S);

  if RelativePath(S)
  then S := FExpand(Directory^ + S)
  else S := FExpand(S);
  FSplit(S, Path, Name, Ext);
  if ((Name = '') or (Ext = '')) and not IsDir(S) then begin
    FSplit(WildCard, TPath, TName, TExt);
    if ((Name = '') and (Ext = ''))
    then S := Path + TName + TExt
    else if Name = ''
         then S := Path + TName + Ext
         else if Ext = '' then begin
                if IsWild(Name)
                then S := Path + Name + TExt
                else S := Path + Name + NoWildChars(TExt);
              end;
  end;
end;

procedure TFileDialog.HandleEvent(var Event: TEvent);
var Value : Integer;
    FType : String;
    FName : String;
    FDisk : Char;
    FDrive: PathStr;
begin
  Value:=FileList^.Focused;
  FName:=Copy(FileList^.GetText(Value,255),1,12);
  FType:=Copy(FileList^.GetText(Value,255),15,2);

  if (FType=' ') or (FType='')
  then begin
    DisableCommands([cmFileOpen,cmFileView]);
    EnableCommands ([cmFileStep]);
  end
  else begin
    EnableCommands ([cmFileOpen,cmFileView]);
    DisableCommands([cmFileStep]);
  end;

  TDialog.HandleEvent(Event);

  if Event.What = evKeyDown then
    if (Event.KeyCode=kbAltF1) or (Event.KeyCode=kbAltF2) then begin
      Event.What   :=evCommand;
      Event.Command:=cmFileDisk;
    end;

  if Event.What = evCommand then
    case Event.Command of
      cmFileOpen,
      cmFileStep : begin
                     EndModal(Event.Command);
                     ClearEvent(Event);
                   end;
      cmFileDisk : begin
                     FDisk:=SelectDrive;
                     if FDisk<>' ' then begin
                       FDrive:=FDisk+':\';
                       if CheckDirectory(FDrive) then begin
                         {$I-}
                         ChDir(FDrive);
                         {$I+}
                         if IoResult<>0 then begin
                           MessageBox(#3'ன⢮ '#13#3+FDrive+#13#3'  ࠡ  ⮢.', nil, mfError + mfOkButton);
                           ChDir(Copy(Directory^,1,Length(Directory^)-1));
                         end
                         else begin
                           DisposeStr(Directory);
                           Directory := NewSTr(FDisk+':\');
                           FileList^.ReadDirectory(Directory^+WildCard);
                         end;
                       end;
                     end;
                   end;
      cmFileView : begin
                     if FName[10]<>' ' then FName[9]:='.';
                     FName:=DelSpace(FName);
                     ViewFile(Directory^+FName);
                   end;
    end;
end;

procedure TFileDialog.ReadDirectory;
begin
  FileList^.ReadDirectory(WildCard);
  Directory := NewStr(GetCurDir);
end;

function TFileDialog.Valid(Command: Word): Boolean;
var
  T    : Boolean;
  FName: PathStr;
  Dir  : DirStr;
  Name : NameStr;
  Ext  : ExtStr;

begin
  if Command = 0 then begin
    Valid := True;
    Exit;
  end
  else Valid := False;

  if TDialog.Valid(Command) then begin
    GetFileName(FName);
    if (Command <> cmCancel) and (Command <> cmFileDisk) then begin
      if IsWild(FName) then begin
        FSplit(FName, Dir, Name, Ext);
        if CheckDirectory(Dir) then begin
          DisposeStr(Directory);
          Directory := NewStr(Dir);
          WildCard  := Name+Ext;
          FileList^.ReadDirectory(Directory^+WildCard);
        end
      end
      else if IsDir(FName) then begin
             if CheckDirectory(FName) then begin
               DisposeStr(Directory);
               Directory := NewSTr(FName+'\');
               FileList^.ReadDirectory(Directory^+WildCard);
             end
           end
           else if ValidFileName(FName)
                then Valid := True
                else begin
                  MessageBox('Invalid file name.', nil, mfError + mfOkButton);
                  Valid := False;
                end
    end
    else Valid := True;
  end;
end;

function TFileDialog.GetTitle;
var TmpPath  : string;
    TmpDrive : string[3];
begin
 TmpPath:=Directory^;
 if length(TmpPath)>MaxSize-4 then begin
  TmpDrive:=Copy(TmpPath,1,3);
  TmpPath :=Copy(TmpPath,4,length(TmpPath));
  while length(TmpPath)>MaxSize-4 do
    TmpPath:=copy(TmpPath,Pos('\',TmpPath)+1,255);
  TmpPath :=TmpDrive+'..\'+TmpPath;
 end;
 TmpPath:=DelSpace(TmpPath);
 Dec(TmpPath[0]);
 GetTitle:=TmpPath;
end;

end.

